<?php
if (!defined('checkaccess')) {
	die('Direct access not permitted');
} 

function is_valid($id, $datareturn) //  IEC 62056 data set structure
{
	$regexp = "/^$id\(-?[A-z0-9\.]+\*[A-z0-9³²%°]+\)$/i"; //ID(VALUE*UNIT)
	if (preg_match($regexp, $datareturn)) {
		$datareturn = preg_replace("/^$id\(/i", '', $datareturn, 1); // VALUE*UNIT)
		$datareturn = preg_replace("/\*[A-z0-9³²%°]+\)$/i", '', $datareturn, 1); // VALUE
	} else {
		$datareturn = null;
	}
	return $datareturn;
}

// Always initialize the return string, it should always be named $CMD_RETURN to allow 'Communication Error' test
$CMD_RETURN = '';

//date_default_timezone_set($DTZ);
//$SDTE = date("Ymd H:i:s");

$I1V = null;
$I1A = null;
$I1P = null;
$I2V = null;
$I2A = null;
$I2P = null;
$EFF = (float) 0.0;
$INVT = null;
$BOOT = null;

$data = exec("cat /dev/shm/metern${'ADR'.$invt_num}.txt | egrep \"^${'ADR'.$invt_num}_V\(\" | egrep \"\*V\)$\"");
$id = "${'ADR'.$invt_num}_V";
$G1V = is_valid($id,$data);
settype($G1V, 'float');

$data = exec("cat /dev/shm/metern${'ADR'.$invt_num}.txt | egrep \"^${'ADR'.$invt_num}_C\(\" | egrep \"\*A\)$\"");
$id = "${'ADR'.$invt_num}_C";
$G1A = is_valid($id,$data);
settype($G1A, 'float');

$data = exec("cat /dev/shm/metern${'ADR'.$invt_num}.txt | egrep \"^${'ADR'.$invt_num}_P\(\" | egrep \"\*W\)$\"");
$id = "${'ADR'.$invt_num}_P";
$G1P = is_valid($id,$data);
settype($G1P, 'float');

$data = exec("cat /dev/shm/metern${'ADR'.$invt_num}.txt | egrep \"^${'ADR'.$invt_num}_F\(\" | egrep \"\*Hz\)$\"");
$id = "${'ADR'.$invt_num}_F";
$FRQ = is_valid($id,$data);
settype($FRQ, 'float');

$data = exec("cat /dev/shm/metern${'ADR'.$invt_num}.txt | egrep \"^${'ADR'.$invt_num}_EE\(\" | egrep \"\*Wh\)$\"");
$id = "${'ADR'.$invt_num}_EE";
$KWHT = is_valid($id,$data);
settype($KWHT, 'float');
$KWHT = $KWHT/1000;

if ($KWHT != 0) {
	$RET = 'OK';
} else {
	$RET = 'NOK';
	$CMD_RETURN = 'No valid data';
}

if ($DEBUG != 0) {
	echo "G1V = $G1V, G1A = $G1A, G1P = $G1P, FRQ = $FRQ, EFF = $EFF, KWHT = $KWHT";
}
?>
